#include "guiapp.h"
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <time.h>
#include <glib.h>
#include <pthread.h>
#include <gtk/gtk.h>
#include <gdk/gdkkeysyms.h>
#include <glib/gconvert.h>

GUIApp guiapp;
GtkWidget *syncname_txt;
GtkWidget *targetip_txt;
GtkWidget *localpath_txt;
GtkWidget *remotepath_txt;

GtkWidget *dialog;


void hide_widget(GtkWidget *);



int GUIApp::run( void )
{
	init();
	init_guimodule();
	connect_guimodule();		

	return 0;
}

int GUIApp::cleanup(void)
{

	return 0;
}


int GUIApp::createSync( char *buf )
{
	printf("GUIApp::createSync ; buf = %s\n", buf);
	
	return sendCmd(UIM_CREATE_SYNC, buf);
}

int GUIApp::deleteSync( char *buf )
{
	printf("GUIApp::deleteSync ; buf = %s\n", buf);

	return sendCmd(UIM_DELETE_SYNC, buf);
	
	//return sendCmd(UIM_DELETE_SYNC, syncBuf);
}


void click_ok(GtkWidget *click_sth)
{
	gtk_entry_set_text(GTK_ENTRY(click_sth), "");
	gtk_widget_hide(dialog);
}


void error_popup()
{
	GtkWidget *label, *btn_ok, *image, *box;
	dialog = gtk_dialog_new();
    gtk_window_set_title(GTK_WINDOW(dialog), "IP ERROR");
    gtk_widget_set_size_request(dialog, 441, 151);
    gtk_window_set_position(GTK_WINDOW(dialog),GTK_WIN_POS_CENTER);
    gtk_window_set_resizable(GTK_WINDOW(dialog), FALSE);
	
	gtk_signal_connect (GTK_OBJECT(dialog), "delete_event", GTK_SIGNAL_FUNC(hide_widget), dialog);

	box = gtk_hbox_new (FALSE, 0);	
        
    label = gtk_label_new("Correct IP!!!! plz~\n");
	gtk_widget_set_uposition(label, 10, 30);
	gtk_box_pack_start(GTK_BOX(box), label, TRUE, TRUE, 0);
	btn_ok = gtk_button_new_with_label("OK");
	gtk_signal_connect_object(GTK_OBJECT(btn_ok), "clicked", GTK_SIGNAL_FUNC(click_ok), targetip_txt);
	
	gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->vbox), box, FALSE, FALSE, 0);

	//gtk_box_pack_start(GTK_BOX(box), btn_ok, TRUE, TRUE, 10);
	//gtk_box_pack_start(GTK_BOX(box), btn_cancel, TRUE, TRUE, 10);
	gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->action_area), btn_ok, FALSE, FALSE, 0);
	gtk_widget_show(image);
	gtk_widget_show(box);
	gtk_widget_show(label);
	gtk_widget_show(btn_ok);

    gtk_widget_show (dialog);
}

void create_Sync(GtkWidget *sth)
{
	char syncBuf[256];	
	bzero( syncBuf, sizeof(syncBuf) );
	char ipBuf[256];	
	bzero( ipBuf, sizeof(ipBuf) );
	sprintf(ipBuf, "%s", gtk_entry_get_text(GTK_ENTRY(targetip_txt)));
	if(!isIPformat(ipBuf))
	{
		error_popup();
	}
	else
	{
		sprintf(syncBuf, "%s %s %s %s", gtk_entry_get_text(GTK_ENTRY(syncname_txt)), gtk_entry_get_text(GTK_ENTRY(targetip_txt)), gtk_entry_get_text(GTK_ENTRY(localpath_txt)),gtk_entry_get_text(GTK_ENTRY(remotepath_txt)));
		if(guiapp.createSync(syncBuf))
		{
			gtk_widget_hide(sth);
		}
	}
}


void delete_Sync(GtkWidget *sth)
{
	char syncBuf[256];	
	bzero( syncBuf, sizeof(syncBuf) );
	
	sprintf(syncBuf, "%s", gtk_entry_get_text(GTK_ENTRY(syncname_txt)));
	
	if(guiapp.deleteSync(syncBuf))
	{
		gtk_widget_hide(sth);
	}
}

bool isIPformat( gchar *str )
{
	int a, b, c, d;
	sscanf( str, "%d.%d.%d.%d", &a, &b, &c, &d );

	if( a >  0  && a < 256  &&
		b >= 0  && b < 256  &&
		c >= 0  && d < 256  &&
		d >  0  && d < 256 )
	{
		return true;
	}

	return false;
}

int GUIApp::init( void )
{
	bzero( remoteTarget, sizeof(remoteTarget) );
	bzero( buf, sizeof(buf) );
	bzero( cmdBuffer, sizeof(cmdBuffer) );

	listenPort 	= UIM_PORT;
	sendPort	= UIM_PORT;
	
    server_len 	= sizeof(server_addr);
	guiapp_len = sizeof(guimodule_addr);

	memset( &guiappData, 0, sizeof(guiappData) );
	memset( &guiappResult, 0, sizeof(guiappResult) );

	return 0;

}


int GUIApp::init_guimodule( void )
{
	guimodule_addr.sin_family = AF_INET;
	guimodule_addr.sin_port = htons( sendPort );

	if( isIPformat( remoteTarget ) )
	{
		guimodule_addr.sin_addr.s_addr = inet_addr( remoteTarget );
	}
	else
	{
		struct hostent *he;
		he = gethostbyname( remoteTarget );

		if( he == NULL )
		{
			return 1;
		}
		else
		{
			guimodule_addr.sin_addr.s_addr = inet_addr( inet_ntoa( *(struct in_addr*)he->h_addr) );
		}
	}

	return 0;
}


int GUIApp::connect_guimodule( void )
{
    if( (guiapp_sockfd = socket(PF_INET, SOCK_STREAM, 0)) < 0 )
    {
		puts("connect_client() socket() failed1");
		return -1;
    }
	
    if( connect(guiapp_sockfd, (struct sockaddr *)&guimodule_addr, guiapp_len) < 0)
    {			
		if( guiapp_sockfd )
		{

			close( guiapp_sockfd );
		}
		return -1;	
    }

	return 0;
}

int GUIApp::sendCmd( int chk, char *cmd )
{
	if( guiapp_sockfd <= 0 )
	{
		printf("uimodule_sockfd is not valid.\n");
		sendResult = CM_ACK_NO;
		return CM_ACK_NO;
	}
	
	switch(chk)
	{
		case UIM_CREATE_SYNC: 
			guiappData.type = UIM_CREATE_SYNC;
			break;

		case UIM_DELETE_SYNC: 
			guiappData.type = UIM_DELETE_SYNC;
			break;

		case UIM_VIEW_SYNCINFO: 
			guiappData.type = UIM_VIEW_SYNCINFO;
			break;
	}

	sprintf( guiappData.data, "%s", cmd);
	guiappData.len = strlen( guiappData.data );
	
	write( guiapp_sockfd, &guiappData, 
			sizeof(guiappData.type) + sizeof(guiappData.len) + strlen(guiappData.data) );

}



void hide_widget(GtkWidget *hide_sth)
{
	gtk_widget_hide(hide_sth);
}

void create_sync_window()
{
	//  
	GtkWidget *create_sync_window; 
	GtkWidget *main_box;
	//  ʿ  Էϴ κ 
    GtkWidget *data_box;
	// شϴ 
	GtkWidget *syncname_lbl;
	GtkWidget *targetip_lbl;
	GtkWidget *localpath_lbl;
	GtkWidget *remotepath_lbl;

	/*
	GtkWidget *syncname_txt;
	GtkWidget *targetip_txt;
	GtkWidget *localpath_txt;
	GtkWidget *remotepath_txt;
	*/
	//button κ 
    GtkWidget *btn_box;
	// ư شϴ 
	GtkWidget *btn_create;
	GtkWidget *btn_cancel;
	
	GtkWidget *arr_txt[4];

	create_sync_window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
    gtk_window_set_title(GTK_WINDOW(create_sync_window), "Acha Create Sync");
    gtk_widget_set_size_request(create_sync_window, 300, 300);	  
    gtk_window_set_position(GTK_WINDOW(create_sync_window),GTK_WIN_POS_CENTER);
    gtk_window_set_resizable(GTK_WINDOW(create_sync_window), FALSE);

	main_box = gtk_vbox_new (FALSE,0); 
    gtk_container_add ( GTK_CONTAINER (create_sync_window), main_box); 

	data_box = gtk_fixed_new(); 	
    gtk_container_add ( GTK_CONTAINER (main_box), data_box); 

	syncname_lbl = gtk_label_new("SyncName");
	targetip_lbl = gtk_label_new("Target IP");
	localpath_lbl = gtk_label_new("Local Path");
	remotepath_lbl = gtk_label_new("Remote Path");
	
	syncname_txt = gtk_entry_new();
	targetip_txt = gtk_entry_new();
	localpath_txt = gtk_entry_new();
	remotepath_txt = gtk_entry_new();
	
	arr_txt[0] = syncname_txt;
	arr_txt[1] = targetip_txt;
	arr_txt[2] = localpath_txt;
	arr_txt[3] = remotepath_txt;
	
	/*
	arr_txt[0] = gtk_entry_new();
	arr_txt[1] = gtk_entry_new();
	arr_txt[2] = gtk_entry_new();
	arr_txt[3] = gtk_entry_new();
	*/	
	
	gtk_fixed_put(GTK_FIXED(data_box), syncname_lbl, 10, 10);
	gtk_fixed_put(GTK_FIXED(data_box), syncname_txt, 100, 10);

	gtk_fixed_put(GTK_FIXED(data_box), targetip_lbl, 10, 40);
	gtk_fixed_put(GTK_FIXED(data_box), targetip_txt, 100, 40);

	gtk_fixed_put(GTK_FIXED(data_box), localpath_lbl, 10, 70);
	gtk_fixed_put(GTK_FIXED(data_box), localpath_txt, 100,70);

	gtk_fixed_put(GTK_FIXED(data_box), remotepath_lbl, 10, 100);
	gtk_fixed_put(GTK_FIXED(data_box), remotepath_txt, 100, 100);

	//button
	btn_box = gtk_hbox_new (FALSE,0);
	gtk_container_add (GTK_CONTAINER (main_box), btn_box);

	btn_cancel = gtk_button_new_with_label ("Cancel");			
	gtk_container_add (GTK_CONTAINER (btn_box), btn_cancel);
	gtk_signal_connect_object (GTK_OBJECT(btn_cancel), "clicked", GTK_SIGNAL_FUNC(hide_widget), create_sync_window);
	
	btn_create = gtk_button_new_with_label ("Create");			
	gtk_container_add (GTK_CONTAINER (btn_box), btn_create);	
	gtk_signal_connect_object (GTK_OBJECT(btn_create), "clicked", GTK_SIGNAL_FUNC(create_Sync), create_sync_window);
	
	gtk_widget_show (syncname_lbl); 
	gtk_widget_show (targetip_lbl); 
	gtk_widget_show (localpath_lbl); 
	gtk_widget_show (remotepath_lbl); 
	
	gtk_widget_show (syncname_txt); 
	gtk_widget_show (targetip_txt); 
	gtk_widget_show (localpath_txt); 
	gtk_widget_show (remotepath_txt); 
	/*
	gtk_widget_show (arr_txt[0]); 
	gtk_widget_show (arr_txt[1]); 
	gtk_widget_show (arr_txt[2]); 
	gtk_widget_show (arr_txt[3]); 
	*/
	gtk_widget_show (data_box);
	gtk_widget_show (btn_create); 
	gtk_widget_show (btn_cancel); 
	gtk_widget_show (btn_box);
	gtk_widget_show (main_box);

	gtk_widget_show (create_sync_window); 
}


void delete_sync_window()
{
	//  
	GtkWidget *delete_sync_window; 
	GtkWidget *main_box;
	//  ʿ  Էϴ κ 
    GtkWidget *data_box;
	// شϴ 
	GtkWidget *syncname_lbl;	

	//button κ 
    GtkWidget *btn_box;
	// ư شϴ 
	GtkWidget *btn_delete;
	GtkWidget *btn_cancel;

	delete_sync_window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
    gtk_window_set_title(GTK_WINDOW(delete_sync_window), "Acha Create Sync");
    gtk_widget_set_size_request(delete_sync_window, 300, 200);	  
    gtk_window_set_position(GTK_WINDOW(delete_sync_window),GTK_WIN_POS_CENTER);
    gtk_window_set_resizable(GTK_WINDOW(delete_sync_window), FALSE);

	main_box = gtk_vbox_new (FALSE,0); 
    gtk_container_add ( GTK_CONTAINER (delete_sync_window), main_box); 

	data_box = gtk_fixed_new(); 	
    gtk_container_add ( GTK_CONTAINER (main_box), data_box); 

	syncname_lbl = gtk_label_new("SyncName");
		
	syncname_txt = gtk_entry_new();
	
	gtk_fixed_put(GTK_FIXED(data_box), syncname_lbl, 10, 10);
	gtk_fixed_put(GTK_FIXED(data_box), syncname_txt, 100, 10);	

	//button
	btn_box = gtk_hbox_new (FALSE,0);
	gtk_container_add (GTK_CONTAINER (main_box), btn_box);
	
	btn_cancel = gtk_button_new_with_label ("Cancel");			
	gtk_container_add (GTK_CONTAINER (btn_box), btn_cancel);	
	gtk_signal_connect_object (GTK_OBJECT(btn_cancel), "clicked", GTK_SIGNAL_FUNC(hide_widget), delete_sync_window);
	
	btn_delete = gtk_button_new_with_label ("Delete");			
	gtk_container_add (GTK_CONTAINER (btn_box), btn_delete);	
	gtk_signal_connect_object (GTK_OBJECT(btn_delete), "clicked", GTK_SIGNAL_FUNC(delete_Sync), delete_sync_window);


	gtk_widget_show (syncname_lbl); 
	gtk_widget_show (syncname_txt); 
	gtk_widget_show (data_box);
	
	gtk_widget_show (btn_delete); 
	gtk_widget_show (btn_cancel);
	gtk_widget_show (btn_box);
	gtk_widget_show (main_box);

	gtk_widget_show (delete_sync_window); 
}

int main( int argc,char *argv[])
{
    gtk_init (&argc, &argv);
	
	guiapp.run();
	
	//  
	GtkWidget *gui_window = NULL;  

	// ڽ 
	GtkWidget *main_box;
	GtkWidget *content_box; 
	
	
	// ִ κ
    GtkWidget *info_box;
	GtkWidget *info_txt;

	
    //ư  κ
    GtkWidget *btn_box;
	//cancel, create ư 
    GtkWidget *btn_create, *btn_delete, *btn_quit;
   

    /* Create the toplevel window */ 
    gui_window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
    gtk_window_set_title(GTK_WINDOW(gui_window), "Acha");
    gtk_widget_set_size_request(gui_window, 800, 400);	  
    gtk_window_set_position(GTK_WINDOW(gui_window),GTK_WIN_POS_CENTER);
    gtk_window_set_resizable(GTK_WINDOW(gui_window), FALSE);

	gtk_signal_connect (GTK_OBJECT(gui_window), "delete_event", GTK_SIGNAL_FUNC(gtk_main_quit), NULL);

    main_box = gtk_vbox_new (FALSE,0); 
    //gtk_widget_set_uposition(main_box, 10, 10);	
    gtk_container_add ( GTK_CONTAINER (gui_window), main_box); 

	content_box = gtk_hbox_new (FALSE,0); 
    //gtk_widget_set_uposition(content_box, 10, 10);	
    gtk_container_add ( GTK_CONTAINER (main_box), content_box);	

	//info
	info_box = gtk_fixed_new(); 
	gtk_container_add ( GTK_CONTAINER (content_box), info_box); 
	GtkTextTagTable *info_tagtbl = gtk_text_tag_table_new();
	GtkTextBuffer *info_buf = gtk_text_buffer_new(info_tagtbl);
	info_txt = gtk_text_view_new_with_buffer (info_buf);
	gtk_fixed_put(GTK_FIXED(info_box), info_txt, 100, 100);
	gtk_text_buffer_set_text(info_buf, "testtesttesttest\ntesttesttesttest", strlen("testtesttesttest\ntesttesttesttest"));
	gtk_text_view_set_buffer(GTK_TEXT_VIEW(info_txt), info_buf);


	//button
	btn_box = gtk_hbox_new (FALSE,0);
	gtk_container_add (GTK_CONTAINER (main_box), btn_box);
	
	btn_create = gtk_button_new_with_label ("Create Sync");			
	gtk_container_add (GTK_CONTAINER (btn_box), btn_create);	
	gtk_signal_connect_object(GTK_OBJECT(btn_create), "clicked", GTK_SIGNAL_FUNC(create_sync_window), NULL);

	btn_delete = gtk_button_new_with_label ("Delete Stnc");			
	gtk_container_add (GTK_CONTAINER (btn_box), btn_delete);
	gtk_signal_connect (GTK_OBJECT(btn_delete), "clicked", GTK_SIGNAL_FUNC(delete_sync_window), NULL);

	btn_quit = gtk_button_new_with_label ("Quit");			
	gtk_container_add (GTK_CONTAINER (btn_box), btn_quit);
	gtk_signal_connect (GTK_OBJECT(btn_quit), "clicked", GTK_SIGNAL_FUNC(gtk_main_quit), NULL);


	//show		
	gtk_widget_show (btn_create); 
	gtk_widget_show (btn_delete);
	gtk_widget_show (btn_quit);
	gtk_widget_show (btn_box);

	gtk_widget_show (info_txt);
 
	gtk_widget_show (info_box);
	gtk_widget_show (content_box);	
	gtk_widget_show (main_box); 
	gtk_widget_show (gui_window); 
	
	gtk_main ();

	//return 0;

}




