#ifndef __GUIApp_H__
#define __GUIApp_H__

#include "acha.h"
#include "cm.h"
#include "sm.h"
#include "fm.h"

class GUIApp
{
	private :
		char username[SDATA];
		char userpass[SDATA];
		char recordLockPath[SDATA];
		
		int listenPort;
		int sendPort;
	
		int control_sockfd;				
		int server_sockfd;				
		int rtarget_sockfd;				
		int guiapp_sockfd;				

		struct sockaddr_in control_addr;
		struct sockaddr_in server_addr;	
		struct sockaddr_in guimodule_addr;	
		struct sockaddr_in rtarget_addr;

		socklen_t control_len;			
		socklen_t server_len;			
		socklen_t guiapp_len;			
		socklen_t rtarget_len;			
		
		cmdData guiappData;				
		cmdData guiappResult;				
		cmdData syncData;

		int receiveResult;				
		int sendResult;					
		char buf[DATASIZ];				
		char cmdBuffer[DATASIZ];		
		char md5buf[SDATA];				


	public :		

		char remoteTarget[SDATA];

		int init( void );		
		int init_guimodule( void );
		int connect_guimodule( void );
		int cleanup( void );			
		int run( void );		


		int createSync(char *);
		int deleteSync(char *);

		int sendCmd( int, char *);



		
};
#endif
